--[[

Timekeeper: Creates a clock in the options interface for the default UI

Written by Luxen De'Mark


]]--

declare("TK", TK or {})

if TK.exists then
	console_print("Timekeeper already appears to be running?")
	return
	--if TK is initialized by another project, no need to run this plugin.
end

TK.exists = true
TK.UI = {}
TK.DisplayMode = gkini.ReadString("Timekeeper", "DisplayMode", "1")

TK.Timer = Timer()








--------------UI Stuff below here------------------

TK.UI.curTime = iup.label {
	title = "00:00:00"
}

TK.UI.DispToggleLocal = iup.stationtoggle {
	title = " Local",
	action = function()
		TK.UI.DispToggleUTC.value = "OFF"
		TK.UI.DispToggleSIT.value = "OFF"
		TK.DisplayMode = "1"
		gkini.WriteString("Timekeeper", "DisplayMode", "1")
		TK.GetTime()
	end,
}

TK.UI.DispToggleUTC = iup.stationtoggle {
	title = " UTC",
	action = function()
		TK.UI.DispToggleLocal.value = "OFF"
		TK.UI.DispToggleSIT.value = "OFF"
		TK.DisplayMode = "2"
		gkini.WriteString("Timekeeper", "DisplayMode", "2")
		TK.GetTime()
	end,
}

TK.UI.DispToggleSIT = iup.stationtoggle {
	title = " SIT",
	action = function()
		TK.UI.DispToggleLocal.value = "OFF"
		TK.UI.DispToggleUTC.value = "OFF"
		TK.DisplayMode = "3"
		gkini.WriteString("Timekeeper", "DisplayMode", "3")
		TK.GetTime()
	end,
}

if TK.DisplayMode == "1" then
	TK.UI.DispToggleLocal.value = "ON"
elseif TK.DisplayMode == "2" then
	TK.UI.DispToggleUTC.value = "ON"
elseif TK.DisplayMode == "3" then
	TK.UI.DispToggleSIT.value = "ON"
else
	TK.UI.DispToggleLocal.value = "ON"
	gkini.WriteString("Timekeeper", "DisplayMode", "1")
end

TK.UI.ClockPanel = iup.stationsubframe {
	iup.vbox {
		iup.hbox {
			iup.label {
				title = "Current time: ",
			},
			TK.UI.curTime,
			iup.fill { },
		},
		iup.stationsubsubframe {
			iup.vbox {
				TK.UI.DispToggleLocal,
				TK.UI.DispToggleUTC,
				TK.UI.DispToggleSIT,
			},
		},
	},
}

iup.Append(OptionsDialog[1][1][1], TK.UI.ClockPanel)






--------------function Stuff below here------------------
TK.UTC = os.time({["year"]=1970, ["month"]=1, ["day"]=1, ["hour"]=0, ["min"]=0, ["sec"]=0})
TK.SWATCH = os.time({["year"]=1970, ["month"]=1, ["day"]=1, ["hour"]=1, ["min"]=0, ["sec"]=0})

function TK.GetTime()
	
	local temp = ""
	if TK.DisplayMode == "1" then
		temp = os.date("%X", os.time())
	elseif TK.DisplayMode == "2" then
		temp = os.date("%X", TK.UTC + os.time())
	elseif TK.DisplayMode == "3" then
		--temp = os.date("%X", TK.SWATCH + os.time())
		--...lol its not that easy XD
		
		local SITminute = tonumber(os.date("%M", TK.SWATCH + os.time()))
		local SIThour = tonumber(os.date("%H", TK.SWATCH + os.time()))
		local SITsecond = tonumber(os.date("%S", TK.SWATCH + os.time()))
		
		local beat = math.floor(((SITminute * 60) + (SIThour * 3600)) / 86.4)
		
		temp = "@" .. tostring(beat)
		
	end
	
	TK.UI.curTime.title = temp
	iup.Refresh(TK.UI.ClockPanel)
	
	TK.Timer:SetTimeout(1000, function() TK.GetTime() end)
	
end

TK.GetTime()





















